diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.36/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.35/src/wifi/test/wifi-phy-ofdma-test.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/test/wifi-phy-ofdma-test.cc	2022-04-30 18:23:58.222735200 -0700
@@ -23,6 +23,8 @@
 #include "ns3/node.h"
 #include "ns3/pointer.h"
 #include "ns3/string.h"
+#include "ns3/double.h"
+#include "ns3/boolean.h"
 #include "ns3/simulator.h"
 #include "ns3/rng-seed-manager.h"
 #include "ns3/constant-position-mobility-model.h"
@@ -499,13 +501,13 @@
     {
       NS_ASSERT_MSG (false, "Unsupported channel width");
     }
-  
+
   HeRu::RuSpec ru1 (ruType, 1, true);
   txVector.SetRu (ru1, rxStaId1);
   txVector.SetMode (HePhy::GetHeMcs7 (), rxStaId1);
   txVector.SetNss (1, rxStaId1);
 
-  HeRu::RuSpec ru2 (ruType, (m_channelWidth == 160 ? 1 : 2), (m_channelWidth == 160 ? false : true));
+  HeRu::RuSpec ru2 (ruType, (m_channelWidth == 160 ? 1 : 2), m_channelWidth != 160);
   txVector.SetRu (ru2, rxStaId2);
   txVector.SetMode (HePhy::GetHeMcs9 (), rxStaId2);
   txVector.SetNss (1, rxStaId2);
@@ -650,12 +652,12 @@
   spectrumChannel->AddPropagationLossModel (lossModel);
   Ptr<ConstantSpeedPropagationDelayModel> delayModel = CreateObject<ConstantSpeedPropagationDelayModel> ();
   spectrumChannel->SetPropagationDelayModel (delayModel);
-  
+
   Ptr<Node> apNode = CreateObject<Node> ();
   Ptr<WifiNetDevice> apDev = CreateObject<WifiNetDevice> ();
   m_phyAp = CreateObject<SpectrumWifiPhy> ();
   m_phyAp->CreateWifiSpectrumPhyInterface (apDev);
-  m_phyAp->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_phyAp->ConfigureStandard (WIFI_STANDARD_80211ax);
   Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel> ();
   m_phyAp->SetErrorRateModel (error);
   m_phyAp->SetDevice (apDev);
@@ -670,7 +672,7 @@
   Ptr<WifiNetDevice> sta1Dev = CreateObject<WifiNetDevice> ();
   m_phySta1 = CreateObject<OfdmaSpectrumWifiPhy> (1);
   m_phySta1->CreateWifiSpectrumPhyInterface (sta1Dev);
-  m_phySta1->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_phySta1->ConfigureStandard (WIFI_STANDARD_80211ax);
   m_phySta1->SetErrorRateModel (error);
   m_phySta1->SetDevice (sta1Dev);
   m_phySta1->SetChannel (spectrumChannel);
@@ -686,7 +688,7 @@
   Ptr<WifiNetDevice> sta2Dev = CreateObject<WifiNetDevice> ();
   m_phySta2 = CreateObject<OfdmaSpectrumWifiPhy> (2);
   m_phySta2->CreateWifiSpectrumPhyInterface (sta2Dev);
-  m_phySta2->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_phySta2->ConfigureStandard (WIFI_STANDARD_80211ax);
   m_phySta2->SetErrorRateModel (error);
   m_phySta2->SetDevice (sta2Dev);
   m_phySta2->SetChannel (spectrumChannel);
@@ -702,7 +704,7 @@
   Ptr<WifiNetDevice> sta3Dev = CreateObject<WifiNetDevice> ();
   m_phySta3 = CreateObject<OfdmaSpectrumWifiPhy> (3);
   m_phySta3->CreateWifiSpectrumPhyInterface (sta3Dev);
-  m_phySta3->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_phySta3->ConfigureStandard (WIFI_STANDARD_80211ax);
   m_phySta3->SetErrorRateModel (error);
   m_phySta3->SetDevice (sta3Dev);
   m_phySta3->SetChannel (spectrumChannel);
@@ -749,17 +751,18 @@
   m_phySta2->AssignStreams (streamNumber);
   m_phySta3->AssignStreams (streamNumber);
 
-  m_phyAp->SetFrequency (m_frequency);
-  m_phyAp->SetChannelWidth (m_channelWidth);
-
-  m_phySta1->SetFrequency (m_frequency);
-  m_phySta1->SetChannelWidth (m_channelWidth);
-
-  m_phySta2->SetFrequency (m_frequency);
-  m_phySta2->SetChannelWidth (m_channelWidth);
-
-  m_phySta3->SetFrequency (m_frequency);
-  m_phySta3->SetChannelWidth (m_channelWidth);
+  auto channelNum = std::get<0> (*WifiPhyOperatingChannel::FindFirst (0, m_frequency, m_channelWidth,
+                                                                      WIFI_STANDARD_80211ax,
+                                                                      WIFI_PHY_BAND_5GHZ));
+
+  m_phyAp->SetOperatingChannel (WifiPhy::ChannelTuple {channelNum, m_channelWidth,
+                                                       (int)(WIFI_PHY_BAND_5GHZ), 0});
+  m_phySta1->SetOperatingChannel (WifiPhy::ChannelTuple {channelNum, m_channelWidth,
+                                                         (int)(WIFI_PHY_BAND_5GHZ), 0});
+  m_phySta2->SetOperatingChannel (WifiPhy::ChannelTuple {channelNum, m_channelWidth,
+                                                         (int)(WIFI_PHY_BAND_5GHZ), 0});
+  m_phySta3->SetOperatingChannel (WifiPhy::ChannelTuple {channelNum, m_channelWidth,
+                                                         (int)(WIFI_PHY_BAND_5GHZ), 0});
 
   Simulator::Schedule (Seconds (0.5), &TestDlOfdmaPhyTransmission::ResetResults, this);
 
@@ -1040,11 +1043,15 @@
   Ptr<WifiNetDevice> apDev = CreateObject<WifiNetDevice> ();
   m_phyAp = CreateObject<OfdmaSpectrumWifiPhy> (0);
   m_phyAp->CreateWifiSpectrumPhyInterface (apDev);
-  m_phyAp->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_phyAp->ConfigureStandard (WIFI_STANDARD_80211ax);
   Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel> ();
   m_phyAp->SetErrorRateModel (error);
-  m_phyAp->SetFrequency (DEFAULT_FREQUENCY);
-  m_phyAp->SetChannelWidth (DEFAULT_CHANNEL_WIDTH);
+  auto channelNum = std::get<0> (*WifiPhyOperatingChannel::FindFirst (0, DEFAULT_FREQUENCY,
+                                                                      DEFAULT_CHANNEL_WIDTH,
+                                                                      WIFI_STANDARD_80211ax,
+                                                                      WIFI_PHY_BAND_5GHZ));
+  m_phyAp->SetOperatingChannel (WifiPhy::ChannelTuple {channelNum, DEFAULT_CHANNEL_WIDTH,
+                                                       (int)(WIFI_PHY_BAND_5GHZ), 0});
   m_phyAp->SetDevice (apDev);
   m_phyAp->SetChannel (spectrumChannel);
   m_phyAp->TraceConnectWithoutContext ("TxPpduUid", MakeCallback (&TestUlOfdmaPpduUid::TxPpduAp, this));
@@ -1058,10 +1065,10 @@
   Ptr<WifiNetDevice> sta1Dev = CreateObject<WifiNetDevice> ();
   m_phySta1 = CreateObject<OfdmaSpectrumWifiPhy> (1);
   m_phySta1->CreateWifiSpectrumPhyInterface (sta1Dev);
-  m_phySta1->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_phySta1->ConfigureStandard (WIFI_STANDARD_80211ax);
   m_phySta1->SetErrorRateModel (error);
-  m_phySta1->SetFrequency (DEFAULT_FREQUENCY);
-  m_phySta1->SetChannelWidth (DEFAULT_CHANNEL_WIDTH);
+  m_phySta1->SetOperatingChannel (WifiPhy::ChannelTuple {channelNum, DEFAULT_CHANNEL_WIDTH,
+                                                         (int)(WIFI_PHY_BAND_5GHZ), 0});
   m_phySta1->SetDevice (sta1Dev);
   m_phySta1->SetChannel (spectrumChannel);
   m_phySta1->TraceConnectWithoutContext ("TxPpduUid", MakeCallback (&TestUlOfdmaPpduUid::TxPpduSta1, this));
@@ -1075,10 +1082,10 @@
   Ptr<WifiNetDevice> sta2Dev = CreateObject<WifiNetDevice> ();
   m_phySta2 = CreateObject<OfdmaSpectrumWifiPhy> (2);
   m_phySta2->CreateWifiSpectrumPhyInterface (sta2Dev);
-  m_phySta2->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_phySta2->ConfigureStandard (WIFI_STANDARD_80211ax);
   m_phySta2->SetErrorRateModel (error);
-  m_phySta2->SetFrequency (DEFAULT_FREQUENCY);
-  m_phySta2->SetChannelWidth (DEFAULT_CHANNEL_WIDTH);
+  m_phySta2->SetOperatingChannel (WifiPhy::ChannelTuple {channelNum, DEFAULT_CHANNEL_WIDTH,
+                                                         (int)(WIFI_PHY_BAND_5GHZ), 0});
   m_phySta2->SetDevice (sta2Dev);
   m_phySta2->SetChannel (spectrumChannel);
   m_phySta2->TraceConnectWithoutContext ("TxPpduUid", MakeCallback (&TestUlOfdmaPpduUid::TxPpduSta2, this));
@@ -1237,8 +1244,8 @@
                                                      m_phySta1->GetPhyBand (), rxStaId2);
   Time txDuration = std::max (txDuration1, txDuration2);
 
-  txVector1.SetLength (HePhy::ConvertHeTbPpduDurationToLSigLength (txDuration, m_phySta1->GetPhyBand ()));
-  txVector2.SetLength (HePhy::ConvertHeTbPpduDurationToLSigLength (txDuration, m_phySta2->GetPhyBand ()));
+  txVector1.SetLength (HePhy::ConvertHeTbPpduDurationToLSigLength (txDuration, txVector1, m_phySta1->GetPhyBand ()).first);
+  txVector2.SetLength (HePhy::ConvertHeTbPpduDurationToLSigLength (txDuration, txVector2, m_phySta2->GetPhyBand ()).first);
 
   m_phySta1->Send (psdus1, txVector1);
   m_phySta2->Send (psdus2, txVector2);
@@ -1385,11 +1392,13 @@
   Ptr<OfdmaSpectrumWifiPhy> m_phy; ///< Phy
 
   uint64_t m_totalBytesDropped; ///< total number of dropped bytes
+  WifiTxVector m_trigVector;    ///< TRIGVECTOR
 };
 
 TestMultipleHeTbPreambles::TestMultipleHeTbPreambles ()
   : TestCase ("UL-OFDMA multiple RX events test"),
-    m_totalBytesDropped (0)
+    m_totalBytesDropped (0),
+    m_trigVector (HePhy::GetHeMcs7 (), 0, WIFI_PREAMBLE_HE_TB, 800, 1, 1, 0, DEFAULT_CHANNEL_WIDTH, false, false)
 {
 }
 
@@ -1404,6 +1413,7 @@
   m_totalBytesDropped = 0;
   //We have to reset PHY here since we do not trigger OFDMA payload RX event in this test
   m_phy->Reset ();
+  m_trigVector.GetHeMuUserInfoMap ().clear ();
 }
 
 void
@@ -1445,6 +1455,8 @@
   txVector.SetMode (HePhy::GetHeMcs7 (), staId);
   txVector.SetNss (1, staId);
 
+  m_trigVector.GetHeMuUserInfoMap ().insert ({staId, HeMuUserInfo {ru, HePhy::GetHeMcs7 (), 1}});
+
   Ptr<Packet> pkt = Create<Packet> (payloadSize);
   WifiMacHeader hdr;
   hdr.SetType (WIFI_MAC_QOSDATA);
@@ -1456,7 +1468,7 @@
 
   Time ppduDuration = m_phy->CalculateTxDuration (psdu->GetSize (), txVector, m_phy->GetPhyBand (), staId);
   Ptr<HePpdu> ppdu = Create<HePpdu> (psdus, txVector, ppduDuration, WIFI_PHY_BAND_5GHZ, uid,
-                                     HePpdu::PSD_HE_TB_NON_OFDMA_PORTION);
+                                     HePpdu::PSD_HE_TB_NON_OFDMA_PORTION, 0);
 
   //Send non-OFDMA part
   Time nonOfdmaDuration = m_phy->GetHePhy ()->CalculateNonOfdmaDurationForHeTb (txVector);
@@ -1470,6 +1482,12 @@
   rxParams->duration = nonOfdmaDuration;
   rxParams->ppdu = ppdu;
 
+  uint16_t length;
+  std::tie (length, ppduDuration) = HePhy::ConvertHeTbPpduDurationToLSigLength (ppduDuration, txVector, m_phy->GetPhyBand ());
+  txVector.SetLength (length);
+  m_trigVector.SetLength (length);
+  auto hePhy = DynamicCast<HePhy> (m_phy->GetPhyEntity (WIFI_MOD_CLASS_HE));
+  hePhy->SetTrigVector (m_trigVector, ppduDuration);
   m_phy->StartRx (rxParams);
 
   //Schedule OFDMA part
@@ -1504,15 +1522,14 @@
 {
   Ptr<WifiNetDevice> dev = CreateObject<WifiNetDevice> ();
   m_phy = CreateObject<OfdmaSpectrumWifiPhy> (0);
-  m_phy->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_phy->ConfigureStandard (WIFI_STANDARD_80211ax);
   Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel> ();
   Ptr<ApWifiMac> mac = CreateObject<ApWifiMac> ();
   mac->SetAttribute ("BeaconGeneration", BooleanValue (false));
   dev->SetMac (mac);
   m_phy->SetErrorRateModel (error);
-  m_phy->SetChannelNumber (DEFAULT_CHANNEL_NUMBER);
-  m_phy->SetFrequency (DEFAULT_FREQUENCY);
-  m_phy->SetChannelWidth (DEFAULT_CHANNEL_WIDTH);
+  m_phy->SetOperatingChannel (WifiPhy::ChannelTuple {DEFAULT_CHANNEL_NUMBER, DEFAULT_CHANNEL_WIDTH,
+                                                     (int)(WIFI_PHY_BAND_5GHZ), 0});
   m_phy->TraceConnectWithoutContext ("PhyRxDrop", MakeCallback (&TestMultipleHeTbPreambles::RxDropped, this));
   m_phy->SetDevice (dev);
   Ptr<ThresholdPreambleDetectionModel> preambleDetectionModel = CreateObject<ThresholdPreambleDetectionModel> ();
@@ -1608,16 +1625,14 @@
 
   {
     //Verify the correct reception of a single UL MU transmission with two stations belonging to the same BSS,
-    //and the second PPDU arrives 500ns after the first PPDU, i.e. it exceeds the delay spread of 400ns
+    //and the second PPDU arrives 500ns after the first PPDU
     std::vector<uint64_t> uids {9};
     Simulator::Schedule (Seconds (6), &TestMultipleHeTbPreambles::RxHeTbPpdu, this, uids[0], 1, txPowerWatts, 1001);
     Simulator::Schedule (Seconds (6) + NanoSeconds (500), &TestMultipleHeTbPreambles::RxHeTbPpdu, this, uids[0], 2, txPowerWatts, 1002);
     //Check that we received a single UL MU transmission with the corresponding UID
     Simulator::Schedule (Seconds (6.0) + MicroSeconds (1), &TestMultipleHeTbPreambles::CheckHeTbPreambles, this, 1, uids);
-    //The first packet of 1001 bytes should be dropped because preamble is not detected after 4us (because the PPDU that arrived at 500ns is interfering):
-    //the second HE TB PPDU is acting as interference since it arrived after the maximum allowed 400ns.
-    //Obviously, that second packet of 1002 bytes is dropped as well.
-    Simulator::Schedule (Seconds (6.0) + MicroSeconds (5), &TestMultipleHeTbPreambles::CheckBytesDropped, this, 1001 + 1002);
+    //No packet is dropped (we check after 5us to verify that PD is successful)
+    Simulator::Schedule (Seconds (6.0) + MicroSeconds (5), &TestMultipleHeTbPreambles::CheckBytesDropped, this, 0);
     Simulator::Schedule (Seconds (6.5), &TestMultipleHeTbPreambles::Reset, this);
   }
 
@@ -1634,6 +1649,19 @@
 class TestUlOfdmaPhyTransmission : public TestCase
 {
 public:
+  /**
+   * Erroneous info included in a TRIGVECTOR
+   */
+  enum TrigVectorInfo
+  {
+    NONE = 0,
+    CHANNEL_WIDTH,
+    UL_LENGTH,
+    AID,
+    RU_TYPE,
+    MCS
+  };
+
   TestUlOfdmaPhyTransmission ();
   virtual ~TestUlOfdmaPhyTransmission ();
 
@@ -1651,6 +1679,13 @@
    */
   WifiTxVector GetTxVectorForHeTbPpdu (uint16_t txStaId, std::size_t index, uint8_t bssColor) const;
   /**
+   * Set TRIGVECTOR for HE TB PPDU
+   *
+   * \param bssColor the BSS color of the TX STA
+   * \param error the erroneous info (if any) in the TRIGVECTOR to set
+   */
+  void SetTrigVector (uint8_t bssColor, TrigVectorInfo error);
+  /**
    * Send HE TB PPDU function
    * \param txStaId the ID of the TX STA
    * \param index the RU index used for the transmission
@@ -1779,11 +1814,13 @@
    * \param expectedBytesFromSta2 the expected number of bytes from STA 2
    * \param scheduleTxSta1 flag indicating to schedule a HE TB PPDU from STA 1
    * \param expectedStateBeforeEnd the expected state of the PHY before the end of the transmission
+   * \param error the erroneous info (if any) in the TRIGVECTOR to set
    */
   void ScheduleTest (Time delay, bool solicited, WifiPhyState expectedStateAtEnd,
                      uint32_t expectedSuccessFromSta1, uint32_t expectedFailuresFromSta1, uint32_t expectedBytesFromSta1,
                      uint32_t expectedSuccessFromSta2, uint32_t expectedFailuresFromSta2, uint32_t expectedBytesFromSta2,
-                     bool scheduleTxSta1 = true, WifiPhyState expectedStateBeforeEnd = WifiPhyState::RX);
+                     bool scheduleTxSta1 = true, WifiPhyState expectedStateBeforeEnd = WifiPhyState::RX,
+                     TrigVectorInfo error = NONE);
 
   /**
    * Schedule power measurement related checks.
@@ -1919,6 +1956,69 @@
 }
 
 void
+TestUlOfdmaPhyTransmission::SetTrigVector (uint8_t bssColor, TrigVectorInfo error)
+{
+  uint16_t channelWidth = m_channelWidth;
+  if (error == CHANNEL_WIDTH)
+    {
+      channelWidth = (channelWidth == 160 ? 20 : channelWidth * 2);
+    }
+
+  WifiTxVector txVector (HePhy::GetHeMcs7 (), 0, WIFI_PREAMBLE_HE_TB, 800, 1, 1, 0,
+                         channelWidth, false, false, false, bssColor);
+
+  HeRu::RuType ruType = HeRu::RU_106_TONE;
+  if (channelWidth == 20)
+    {
+      ruType = (error == RU_TYPE ? HeRu::RU_52_TONE : HeRu::RU_106_TONE);
+    }
+  else if (channelWidth == 40)
+    {
+      ruType = (error == RU_TYPE ? HeRu::RU_106_TONE : HeRu::RU_242_TONE);
+    }
+  else if (channelWidth == 80)
+    {
+      ruType = (error == RU_TYPE ? HeRu::RU_242_TONE : HeRu::RU_484_TONE);
+    }
+  else if (channelWidth == 160)
+    {
+      ruType = (error == RU_TYPE ? HeRu::RU_484_TONE : HeRu::RU_996_TONE);
+    }
+  else
+    {
+      NS_ASSERT_MSG (false, "Unsupported channel width");
+    }
+
+  uint16_t aid1 = (error == AID ? 3 : 1);
+  uint16_t aid2 = (error == AID ? 4 : 2);
+
+  HeRu::RuSpec ru1 (ruType, 1, true);
+  ru1.SetPhyIndex (channelWidth, 0);
+  txVector.SetRu (ru1, aid1);
+  txVector.SetMode ((error == MCS ? HePhy::GetHeMcs5 () : HePhy::GetHeMcs7 ()), aid1);
+  txVector.SetNss (1, aid1);
+
+  HeRu::RuSpec ru2 (ruType, (channelWidth == 160 ? 1 : 2),
+                    (channelWidth == 160 ? false : true));
+  ru2.SetPhyIndex (channelWidth, 0);
+  txVector.SetRu (ru2, aid2);
+  txVector.SetMode ((error == MCS ? HePhy::GetHeMcs5 () : HePhy::GetHeMcs7 ()), aid2);
+  txVector.SetNss (1, aid2);
+
+  uint16_t length;
+  std::tie (length, m_expectedPpduDuration) = HePhy::ConvertHeTbPpduDurationToLSigLength (m_expectedPpduDuration,
+                                                                                          txVector,
+                                                                                          m_phyAp->GetPhyBand ());
+  if (error == UL_LENGTH)
+    {
+      ++length;
+    }
+  txVector.SetLength (length);
+  auto hePhyAp = DynamicCast<HePhy> (m_phyAp->GetPhyEntity (WIFI_MOD_CLASS_HE));
+  hePhyAp->SetTrigVector (txVector, m_expectedPpduDuration);
+}
+
+void
 TestUlOfdmaPhyTransmission::SendHeTbPpdu (uint16_t txStaId, std::size_t index, std::size_t payloadSize, uint64_t uid, uint8_t bssColor)
 {
   NS_LOG_FUNCTION (this << txStaId << index << payloadSize << uid << +bssColor);
@@ -1952,7 +2052,7 @@
     }
 
   Time txDuration = phy->CalculateTxDuration (psdu->GetSize (), txVector, phy->GetPhyBand (), txStaId);
-  txVector.SetLength (HePhy::ConvertHeTbPpduDurationToLSigLength (txDuration, phy->GetPhyBand ()));
+  txVector.SetLength (HePhy::ConvertHeTbPpduDurationToLSigLength (txDuration, txVector, phy->GetPhyBand ()).first);
 
   phy->SetPpduUid (uid);
   phy->Send (psdus, txVector);
@@ -2125,19 +2225,20 @@
   spectrumChannel->AddPropagationLossModel (lossModel);
   Ptr<ConstantSpeedPropagationDelayModel> delayModel = CreateObject<ConstantSpeedPropagationDelayModel> ();
   spectrumChannel->SetPropagationDelayModel (delayModel);
-  
+
   Ptr<ThresholdPreambleDetectionModel> preambleDetectionModel = CreateObject<ThresholdPreambleDetectionModel> ();
   preambleDetectionModel->SetAttribute ("MinimumRssi", DoubleValue (-8)); //to ensure that transmission in neighboring channel is ignored (16 dBm baseline)
   preambleDetectionModel->SetAttribute ("Threshold", DoubleValue (-100)); //no limit on SNR
 
   Ptr<Node> apNode = CreateObject<Node> ();
   Ptr<WifiNetDevice> apDev = CreateObject<WifiNetDevice> ();
+  apDev->SetStandard (WIFI_STANDARD_80211ax);
   Ptr<ApWifiMac> apMac = CreateObject<ApWifiMac> ();
   apMac->SetAttribute ("BeaconGeneration", BooleanValue (false));
   apDev->SetMac (apMac);
   m_phyAp = CreateObject<OfdmaSpectrumWifiPhy> (0);
   m_phyAp->CreateWifiSpectrumPhyInterface (apDev);
-  m_phyAp->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_phyAp->ConfigureStandard (WIFI_STANDARD_80211ax);
   Ptr<HeConfiguration> heConfiguration = CreateObject<HeConfiguration> ();
   apDev->SetHeConfiguration (heConfiguration);
   Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel> ();
@@ -2157,7 +2258,7 @@
   Ptr<WifiNetDevice> sta1Dev = CreateObject<WifiNetDevice> ();
   m_phySta1 = CreateObject<OfdmaSpectrumWifiPhy> (1);
   m_phySta1->CreateWifiSpectrumPhyInterface (sta1Dev);
-  m_phySta1->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_phySta1->ConfigureStandard (WIFI_STANDARD_80211ax);
   m_phySta1->SetErrorRateModel (error);
   m_phySta1->SetDevice (sta1Dev);
   m_phySta1->SetChannel (spectrumChannel);
@@ -2172,7 +2273,7 @@
   Ptr<WifiNetDevice> sta2Dev = CreateObject<WifiNetDevice> ();
   m_phySta2 = CreateObject<OfdmaSpectrumWifiPhy> (2);
   m_phySta2->CreateWifiSpectrumPhyInterface (sta2Dev);
-  m_phySta2->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_phySta2->ConfigureStandard (WIFI_STANDARD_80211ax);
   m_phySta2->SetErrorRateModel (error);
   m_phySta2->SetDevice (sta2Dev);
   m_phySta2->SetChannel (spectrumChannel);
@@ -2187,7 +2288,7 @@
   Ptr<WifiNetDevice> sta3Dev = CreateObject<WifiNetDevice> ();
   m_phySta3 = CreateObject<OfdmaSpectrumWifiPhy> (3);
   m_phySta3->CreateWifiSpectrumPhyInterface (sta3Dev);
-  m_phySta3->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_phySta3->ConfigureStandard (WIFI_STANDARD_80211ax);
   m_phySta3->SetErrorRateModel (error);
   m_phySta3->SetDevice (sta3Dev);
   m_phySta3->SetChannel (spectrumChannel);
@@ -2243,16 +2344,28 @@
 TestUlOfdmaPhyTransmission::ScheduleTest (Time delay, bool solicited, WifiPhyState expectedStateAtEnd,
                                           uint32_t expectedSuccessFromSta1, uint32_t expectedFailuresFromSta1, uint32_t expectedBytesFromSta1,
                                           uint32_t expectedSuccessFromSta2, uint32_t expectedFailuresFromSta2, uint32_t expectedBytesFromSta2,
-                                          bool scheduleTxSta1, WifiPhyState expectedStateBeforeEnd)
+                                          bool scheduleTxSta1, WifiPhyState expectedStateBeforeEnd,
+                                          TrigVectorInfo error)
 {
-  //AP send SU packet with UID = 0 (2) to mimic transmission of solicited (unsolicited) HE TB PPDUs
-  Simulator::Schedule (delay - MilliSeconds (10), &TestUlOfdmaPhyTransmission::SendHeSuPpdu, this, 0, 50, solicited ? 0 : 2, 0);
+  static uint64_t uid = 0;
+
+  //AP sends an SU packet preceding HE TB PPDUs
+  Simulator::Schedule (delay - MilliSeconds (10), &TestUlOfdmaPhyTransmission::SendHeSuPpdu, this, 0, 50, ++uid, 0);
+  if (!solicited)
+    {
+      // UID of TB PPDUs will be different than the one of the preceding frame
+      ++uid;
+    }
+  else
+    {
+      Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::SetTrigVector, this, 0, error);
+    }
   //STA1 and STA2 send MU UL PPDUs addressed to AP
   if (scheduleTxSta1)
     {
-      Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::SendHeTbPpdu, this, 1, 1, 1000, 0, 0);
+      Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::SendHeTbPpdu, this, 1, 1, 1000, uid, 0);
     }
-  Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::SendHeTbPpdu, this, 2, 2, 1001, 0, 0);
+  Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::SendHeTbPpdu, this, 2, 2, 1001, uid, 0);
 
   //Verify it takes m_expectedPpduDuration to transmit the PPDUs
   Simulator::Schedule (delay + m_expectedPpduDuration - NanoSeconds (1), &TestUlOfdmaPhyTransmission::CheckPhyState, this, m_phyAp, expectedStateBeforeEnd);
@@ -2366,17 +2479,18 @@
   m_phySta2->AssignStreams (streamNumber);
   m_phySta3->AssignStreams (streamNumber);
 
-  m_phyAp->SetFrequency (m_frequency);
-  m_phyAp->SetChannelWidth (m_channelWidth);
-
-  m_phySta1->SetFrequency (m_frequency);
-  m_phySta1->SetChannelWidth (m_channelWidth);
-
-  m_phySta2->SetFrequency (m_frequency);
-  m_phySta2->SetChannelWidth (m_channelWidth);
-
-  m_phySta3->SetFrequency (m_frequency);
-  m_phySta3->SetChannelWidth (m_channelWidth);
+  auto channelNum = std::get<0> (*WifiPhyOperatingChannel::FindFirst (0, m_frequency, m_channelWidth,
+                                                                      WIFI_STANDARD_80211ax,
+                                                                      WIFI_PHY_BAND_5GHZ));
+
+  m_phyAp->SetOperatingChannel (WifiPhy::ChannelTuple {channelNum, m_channelWidth,
+                                                       (int)(WIFI_PHY_BAND_5GHZ), 0});
+  m_phySta1->SetOperatingChannel (WifiPhy::ChannelTuple {channelNum, m_channelWidth,
+                                                         (int)(WIFI_PHY_BAND_5GHZ), 0});
+  m_phySta2->SetOperatingChannel (WifiPhy::ChannelTuple {channelNum, m_channelWidth,
+                                                         (int)(WIFI_PHY_BAND_5GHZ), 0});
+  m_phySta3->SetOperatingChannel (WifiPhy::ChannelTuple {channelNum, m_channelWidth,
+                                                         (int)(WIFI_PHY_BAND_5GHZ), 0});
 
   Time delay = Seconds (0.0);
   Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::Reset, this);
@@ -2401,13 +2515,69 @@
   delay += Seconds (1.0);
 
   //---------------------------------------------------------------------------
-  //Verify that both unsolicited HE TB PPDUs have been corrected received
+  //Verify that no unsolicited HE TB PPDU is received
   Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::LogScenario, this,
-                       "Reception of unsolicited HE TB PPDUs");
+                       "Dropping of unsolicited HE TB PPDUs");
   ScheduleTest (delay, false,
                 WifiPhyState::IDLE,
-                1, 0, 1000,  //One PSDU of 1000 bytes should have been successfully received from STA 1
-                1, 0, 1001); //One PSDU of 1001 bytes should have been successfully received from STA 2
+                0, 0, 0,  //PSDU from STA 1 is not received (no TRIGVECTOR)
+                0, 0, 0,  //PSDU from STA 2 is not received (no TRIGVECTOR)
+                true, WifiPhyState::CCA_BUSY);
+  delay += Seconds (1.0);
+
+  //---------------------------------------------------------------------------
+  //Verify that HE TB PPDUs with channel width differing from TRIGVECTOR are discarded
+  Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::LogScenario, this,
+                       "Dropping of HE TB PPDUs with channel width differing from TRIGVECTOR");
+  ScheduleTest (delay, true,
+                WifiPhyState::IDLE,
+                0, 0, 0,  //PSDU from STA 1 is not received (no TRIGVECTOR)
+                0, 0, 0,  //PSDU from STA 2 is not received (no TRIGVECTOR)
+                true, WifiPhyState::CCA_BUSY, CHANNEL_WIDTH);
+  delay += Seconds (1.0);
+
+  //---------------------------------------------------------------------------
+  //Verify that HE TB PPDUs with UL Length differing from TRIGVECTOR are discarded
+  Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::LogScenario, this,
+                       "Dropping of HE TB PPDUs with UL Length differing from TRIGVECTOR");
+  ScheduleTest (delay, true,
+                WifiPhyState::IDLE,
+                0, 0, 0,  //PSDU from STA 1 is not received (no TRIGVECTOR)
+                0, 0, 0,  //PSDU from STA 2 is not received (no TRIGVECTOR)
+                true, WifiPhyState::CCA_BUSY, UL_LENGTH);
+  delay += Seconds (1.0);
+
+  //---------------------------------------------------------------------------
+  //Verify that HE TB PPDUs with AIDs differing from TRIGVECTOR are discarded
+  Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::LogScenario, this,
+                       "Dropping of HE TB PPDUs with AIDs differing from TRIGVECTOR");
+  ScheduleTest (delay, true,
+                WifiPhyState::IDLE,
+                0, 0, 0,  //PSDU from STA 1 is not received (no TRIGVECTOR)
+                0, 0, 0,  //PSDU from STA 2 is not received (no TRIGVECTOR)
+                true, WifiPhyState::CCA_BUSY, AID);
+  delay += Seconds (1.0);
+
+  //---------------------------------------------------------------------------
+  //Verify that HE TB PPDUs with RU type differing from TRIGVECTOR are discarded
+  Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::LogScenario, this,
+                       "Dropping of HE TB PPDUs with RU type differing from TRIGVECTOR");
+  ScheduleTest (delay, true,
+                WifiPhyState::IDLE,
+                0, 0, 0,  //PSDU from STA 1 is not received (no TRIGVECTOR)
+                0, 0, 0,  //PSDU from STA 2 is not received (no TRIGVECTOR)
+                true, WifiPhyState::CCA_BUSY, RU_TYPE);
+  delay += Seconds (1.0);
+
+  //---------------------------------------------------------------------------
+  //Verify that HE TB PPDUs with MCS differing from TRIGVECTOR are discarded
+  Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::LogScenario, this,
+                       "Dropping of HE TB PPDUs with MCS differing from TRIGVECTOR");
+  ScheduleTest (delay, true,
+                WifiPhyState::IDLE,
+                0, 0, 0,  //PSDU from STA 1 is not received (no TRIGVECTOR)
+                0, 0, 0,  //PSDU from STA 2 is not received (no TRIGVECTOR)
+                true, WifiPhyState::CCA_BUSY, MCS);
   delay += Seconds (1.0);
 
   //---------------------------------------------------------------------------
@@ -2435,18 +2605,6 @@
   delay += Seconds (1.0);
 
   //---------------------------------------------------------------------------
-  //Generate an interference on RU 1 and verify that only STA 1's unsolicited HE TB PPDU has been impacted
-  Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::LogScenario, this,
-                       "Reception of unsolicited HE TB PPDUs with interference on RU 1 during PSDU reception");
-  //A strong non-wifi interference is generated on RU 1 during PSDU reception
-  Simulator::Schedule (delay + MicroSeconds (50), &TestUlOfdmaPhyTransmission::GenerateInterference, this, interferencePsdRu1, MilliSeconds (100));
-  ScheduleTest (delay, false,
-                WifiPhyState::CCA_BUSY, //PHY should move to CCA_BUSY instead of IDLE due to the interference (primary channel)
-                0, 1, 0,     //Reception of the PSDU from STA 1 should have failed (since interference occupies RU 1)
-                1, 0, 1001); //One PSDU of 1001 bytes should have been successfully received from STA 2
-  delay += Seconds (1.0);
-
-  //---------------------------------------------------------------------------
   //Generate an interference on RU 2 and verify that only STA 2's solicited HE TB PPDU has been impacted
   Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::LogScenario, this,
                        "Reception of solicited HE TB PPDUs with interference on RU 2 during PSDU reception");
@@ -2469,18 +2627,6 @@
   delay += Seconds (1.0);
 
   //---------------------------------------------------------------------------
-  //Generate an interference on RU 2 and verify that only STA 2's unsolicited HE TB PPDU has been impacted
-  Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::LogScenario, this,
-                       "Reception of unsolicited HE TB PPDUs with interference on RU 2 during PSDU reception");
-  //A strong non-wifi interference is generated on RU 2 during PSDU reception
-  Simulator::Schedule (delay + MicroSeconds (50), &TestUlOfdmaPhyTransmission::GenerateInterference, this, interferencePsdRu2, MilliSeconds (100));
-  ScheduleTest (delay, false,
-                (m_channelWidth >= 40) ? WifiPhyState::IDLE : WifiPhyState::CCA_BUSY, //PHY should move to CCA_BUSY instead of IDLE if interference on primary channel
-                1, 0, 1000, //One PSDU of 1000 bytes should have been successfully received from STA 1
-                0, 1, 0);   //Reception of the PSDU from STA 2 should have failed (since interference occupies RU 2)
-  delay += Seconds (1.0);
-
-  //---------------------------------------------------------------------------
   //Generate an interference on the full band and verify that both solicited HE TB PPDUs have been impacted
   Simulator::Schedule (delay, &TestUlOfdmaPhyTransmission::LogScenario, this,
                        "Reception of solicited HE TB PPDUs with interference on the full band during PSDU reception");
